[ "$PM2_SYS" = IRIX_SYS ] && PM2_MARCEL_CFLAGS="$PM2_MARCEL_CFLAGS -fno-omit-frame-pointer"
PM2_MARCEL_CFLAGS="$PM2_MARCEL_CFLAGS -I${PM2_ROOT}/marcel/autogen-include -D__STDC_LIMIT_MACROS"
[ "$PM2_SYS" != DARWIN_SYS ] && PM2_MARCEL_CFLAGS_KERNEL="$PM2_MARCEL_CFLAGS_KERNEL -D_POSIX_C_SOURCE=200112"
PM2_MARCEL_CFLAGS_KERNEL="$PM2_MARCEL_CFLAGS_KERNEL -D_GNU_SOURCE"
PM2_MARCEL_CFLAGS_KERNEL="$PM2_MARCEL_CFLAGS_KERNEL -Wmissing-prototypes"

case "$PM2_SYS" in
    SOLARIS_SYS)
    	PM2_MARCEL_CFLAGS_KERNEL="$PM2_MARCEL_CFLAGS_KERNEL -D_XOPEN_SOURCE=500 -D_STDC_C99 -D_XPG6 -std=gnu99 -D__EXTENSIONS__"
	;;
    DARWIN_SYS)
	;;
    *)                                                     
    	PM2_MARCEL_CFLAGS_KERNEL="$PM2_MARCEL_CFLAGS_KERNEL -D_XOPEN_SOURCE=600"
	;;
esac

[ "$PM2_SYS" = OSF_SYS ] && PM2_MARCEL_CFLAGS="$PM2_MARCEL_CFLAGS -D_OSF_SOURCE"
[ "$PM2_SYS" = AIX_SYS ] && PM2_MARCEL_CFLAGS="$PM2_MARCEL_CFLAGS -D_ALL_SOURCE"

case " $PM2_LIBS " in
    *\ mad?\ *) ;;
    *) PM2_DEFAULT_LOADER=${PM2_ROOT}/marcel/bin/marcelload_conf_not_needed ;;
esac

if [ "$PM2_SYS" = SOLARIS_SYS ]; then
    PM2_MARCEL_LIBS="$PM2_MARCEL_LIBS -lsocket"
    if [ "$PM2_ARCH" = X86_ARCH ]; then
	PM2_MARCEL_LIBS="$PM2_MARCEL_LIBS -lrt"
    else
	PM2_MARCEL_LIBS="$PM2_MARCEL_LIBS -lposix4"
    fi
fi

if [ "$PM2_SYS" = OSF_SYS ]; then
    PM2_MARCEL_LIBS="$PM2_MARCEL_LIBS -lrt"
fi

if [ "$PM2_SYS" = LINUX_SYS ]; then
    VERSION=`uname -r | cut -d . -f 1`
    PATCHLEVEL=`uname -r | cut -d . -f 2`
    PM2_MARCEL_CFLAGS_KERNEL="$PM2_MARCEL_CFLAGS_KERNEL -DLINUX_VERSION=\"\\\"$VERSION.$PATCHLEVEL\\\"\""
    [ "$VERSION" -lt 2 -o "$PATCHLEVEL" -lt 6 ] && PM2_MARCEL_CFLAGS_KERNEL="$PM2_MARCEL_CFLAGS_KERNEL -DOLD_ITIMER_REAL"
fi

PM2_MARCEL_GENERATE_INCLUDE=true
