/** @file
 * PadicoTM generic bootstrap process
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dlfcn.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/un.h>

#include "padico_config.h"
#ifdef PADICO_ENABLE_PUKABI
#include "Puk-ABI.h"
#endif

#include "Puk.h"

void padico_bugfix();


static void padico_d_main(int argc, char* argv[])
{

#ifdef PADICO_ENABLE_PUKABI
  /* defeat LD_PRELOAD inheritance! */
  puk_abi_init();
#endif

  padico_puk_bootstrap(argc, argv);

  fprintf(stderr, "padico-d: exit.\n");

  _exit(0);
}


int main(int argc, char* argv[])
{
  padico_d_main(argc, argv);
  return 0;
}


/* dependancies for some Fortran symbols */

void getarg_()
{}

void iargc_()
{}

void pmpi_wtick_()
{}

void pmpi_wtime_()
{}

void padico_bugfix_mpi_f77()
{
  getarg_();
  iargc_();
  pmpi_wtick_();
  pmpi_wtime_();
}

void padico_bugfix()
{
  padico_bugfix_mpi_f77();
}

