/** @file Miscellaneous oracles for number of args of variadic functions
 * @ingroup Puk
 */

#include <stdio.h>
#include <unistd.h>
#include <poll.h>
#include <fcntl.h>

#include "Puk-ABI.h"


int puk_abi_oracle__fcntl(int cmd)
{
  int o = -1;
  switch(cmd)
    {
    case F_DUPFD:
    case F_GETFD:
    case F_GETFL:
      o = 0;
      break;

    case F_SETFD:
    case F_SETFL:
      o = 1;
      break;
      
    case F_GETLK:
    case F_SETLK:
    case F_SETLKW:
#if F_GETLK64 != F_GETLK
    case F_GETLK64:
    case F_SETLK64:
    case F_SETLKW64:
#endif
      o = 2;
      break;
      
    default:
      puk_abi_print("PukABI: warning- fcntl() called with unsupported option %d", cmd);
      o = 2;
      break;
    }
  return o;
}

int puk_abi_oracle__open(int oflag)
{
  return(oflag & O_CREAT);
}

