
AC_DEFUN([AC_PADICO_TOOLS_DIR],
	 [ padico_tools_dir="$1" ])

# ## check build directory
AC_DEFUN([AC_PADICO_BUILDDIR],
	 [ AC_MSG_CHECKING([PadicoTM build directory])
	   padico_builddir=`pwd`
	   if test -r ./configure; then
	     AC_MSG_ERROR([ *** PadicoTM should not be configured in its source tree. Create a separate 'build' dir instead. ])
	   fi
	   AC_SUBST(padico_builddir)
	   AC_MSG_RESULT(${padico_builddir})
	   padico_root=$prefix
           AC_SUBST(padico_root)
           AC_DEFINE_UNQUOTED(PADICO_ROOT, "${padico_root}/", 
                              [Padico root install directory])

           if test x$prefix = xNONE; then
             AC_MSG_ERROR([No prefix given. Please supply a '--prefix' parameter.])
           fi
	 ])
# ## check source directory
AC_DEFUN([AC_PADICO_SRCDIR],
	 [ AC_MSG_CHECKING([PadicoTM source directory])
	   case ${srcdir} in
	     /*) padico_srcdir=${srcdir} ;;
	     *)  padico_srcdir="`pwd`/${srcdir}" ;;
	   esac
	   AC_SUBST(padico_srcdir)
	   AC_MSG_RESULT(${padico_srcdir})
	 ])

#  ## Various installation directories
AC_DEFUN([AC_PADICO_DIRS],
	 [ AC_REQUIRE([AC_PADICO_BUILDDIR])
	   padico_bin_path=${padico_root}/bin
	   AC_SUBST(padico_bin_path)
	   AC_DEFINE_UNQUOTED(PADICO_BIN_PATH, "${padico_bin_path}/",
                              [Padico bin directory (usually PADICO_ROOT/bin)])

           padico_libexec_path=${padico_root}/libexec
           AC_SUBST(padico_libexec_path)
           AC_DEFINE_UNQUOTED(PADICO_LIBEXEC_PATH, "${padico_libexec_path}/",
                              [Padico libexec directory (usually PADICO_ROOT/libexec)])

           padico_mod_path=${padico_root}/var/mod
           AC_SUBST(padico_mod_path)
           AC_DEFINE_UNQUOTED(PADICO_MOD_PATH, "${padico_mod_path}/",
                              [Padico modules directory (usually PADICO_ROOT/var/mod)])
	 ])


# ## Version and version strings
AC_DEFUN([AC_PADICO_VERSION],
	 [ AC_REQUIRE([AC_PADICO_SRCDIR])
	   PACKAGE_NAME="PadicoTM"
	   PACKAGE_VERSION="`cat ${padico_srcdir}/../VERSION`"
	   PACKAGE_STRING="PadicoTM-${PACKAGE_VERSION}"
 	   PACKAGE_TARNAME="${PACKAGE_STRING}.tar.gz"
           PACKAGE_BUGREPORT="<padico-users@listes.irisa.fr>"

           padico_build_string="${PACKAGE_STRING} (`date`)"
	   AC_DEFINE_UNQUOTED(PADICO_BUILD_STRING, "${padico_build_string}", [date of the build])

           padico_version_major=`echo ${PACKAGE_VERSION} | cut -d. -f1`
	   padico_version_minor=`echo ${PACKAGE_VERSION} | cut -d. -f2`
	   padico_version_micro=`echo ${PACKAGE_VERSION} | cut -d. -f3`

	   AC_DEFINE_UNQUOTED(PADICO_VERSION_MAJOR, ${padico_version_major},
	                      [Padico major version number (eg. '0' for version '0.2.1')])
	   AC_DEFINE_UNQUOTED(PADICO_VERSION_MINOR, ${padico_version_minor},
			      [Padico minor version number (eg. '2' for version '0.2.1')])
	   AC_DEFINE_UNQUOTED(PADICO_VERSION_MICRO, ${padico_version_micro},
			      [Padico revision (eg. '1-beta2' for version '0.2.1-beta2')])
	   AC_DEFINE_UNQUOTED(PADICO_VERSION_STRING, "${PACKAGE_STRING}",
			      [Padico version as string])
	 ])

