
AC_DEFUN([AC_PADICO_OUT_COMMON],
	 [ AC_SUBST_FILE(common_vars_mk)dnl
	   common_vars_mk=${padico_builddir}/${padico_tools_dir}/common_vars.mk
	   out_mk="${padico_tools_dir}/common_vars.mk $out_mk ${padico_tools_dir}/padico-core-wrapper.sh"
	   out_sh="$out_sh ${padico_tools_dir}/padico-cc \
			   ${padico_tools_dir}/padico-c++ \
	   		   ${padico_tools_dir}/padico-cdep \
		 	   ${padico_tools_dir}/padico-mkmod \
	 		   ${padico_tools_dir}/padico-checkmod \
			   ${padico_tools_dir}/padico-config"

	   AC_SUBST_FILE(common_rules_mk)dnl
	   common_rules_mk=${padico_builddir}/${padico_tools_dir}/common_rules.mk
	   out_mk="${padico_tools_dir}/common_rules.mk $out_mk"

	   AC_SUBST_FILE(core_vars_mk)
	   core_vars_mk=${padico_builddir}/${padico_tools_dir}/core_vars.mk
	   out_mk="${out_mk} ${padico_tools_dir}/core_vars.mk"

	   out_mk="${out_mk} ${padico_tools_dir}/Makefile"
	  ])

AC_DEFUN([AC_PADICO_OUT_PUK],
	 [ dnl --- Puk/
	   out_mk="${out_mk} Puk/Makefile Puk/PukABI/Makefile Puk/PadicoBoot/Makefile"
	   dnl --- Puk/PukABI
	   out_sh="${out_sh} Puk/PukABI/puk-abi-getsymbols.sh Puk/PukABI/puk-abi-wrap.sh"
	   dnl --- Puk/PadicoBoot/
	   out_sh="${out_sh} Puk/PadicoBoot/padico-d \
 		  	     Puk/PadicoBoot/padico-boot \
 		  	     Puk/PadicoBoot/padico-launch \
		  	     Puk/PadicoBoot/padico-pbs-submit \
                  	     Puk/PadicoBoot/padico-oar-submit"
	   dnl --- Puk/System/
	   out_mk="$out_mk Puk/System/Makefile"
	 ])

AC_DEFUN([AC_PADICO_OUT_MODULES],
	 [ dnl --- Core/
	   out_mk="${out_mk} Core/Makefile"
	   out_sh="${out_sh} Core/padico-mkcore Core/padico-core-assistant Core/PadicoTM/padico-marcelize"
	   coremods=`cd ${padico_srcdir}/Core; find * -type d|grep -v CVS|tr '\n' ' '`
	   for m in ${coremods}; do
	     if test -r ${padico_srcdir}/Core/${m}/Makefile.in; then
	       out_mk="${out_mk} Core/${m}/Makefile"
	     fi
	     if test -r ${padico_srcdir}/Core/${m}/${m}.map.in; then
	       out_mk="${out_mk} Core/${m}/${m}.map"
	     fi
	   done
	   dnl --- Services/
	   out_mk="${out_mk} Services/Makefile"
	   out_sh="${out_sh} Services/padico-mkservice"
	   services=`cd ${padico_srcdir}/Services; find * -type d|grep -v CVS|tr '\n' ' '`
	   for service in ${services}; do
	     if test -r ${padico_srcdir}/Services/${service}/Makefile.in; then
	       out_mk="${out_mk} Services/${service}/Makefile"
	     fi
	     if test -r ${padico_srcdir}/Services/${service}/${service}.map.in; then
	       out_mk="${out_mk} Services/${service}/${service}.map"
	     fi
	   done
	   dnl --- Services/MPCircuit/
	   out_sh="${out_sh} Services/MPCircuit/padico-mpcrun"
	 ])

AC_DEFUN([AC_PADICO_OUT_ROOT],
	 [ out_mk="${out_mk} Makefile" ])

AC_DEFUN([AC_PADICO_OUTPUT],
	 [ AC_OUTPUT_COMMANDS([chmod +x ${out_sh} ], [ out_sh="${out_sh}" ])
	   AC_OUTPUT(${out_mk} ${out_sh})
	 ])
