

.PHONY: config check-config-tools clean-config


# files generated with "make config"
# warning: these files are deleted by "make clean"
CONFIG_FILES = PadicoTM/configure \
               PadicoTM/Puk/padico_config.h.in \
               PadicoControl/PadicoRun/configure \
               PadicoControl/GControl/configure \
               PadicoControl/NSConfig/configure \
               PadicoControl/ModuleTool/configure

# configuration rules
# ###

config: check-config-tools $(CONFIG_FILES)

check-config-tools:
	@echo "# Checking config tools versions..."
	@( autoconf_ver="`$${AUTOCONF:-autoconf} --version | grep 'GNU Autoconf'`"; \
	   if [ "x$$autoconf_ver" = "x" ]; then echo "Bad autoconf version (should be at least GNU 2.50)"; exit 1; \
           else echo "  $$autoconf_ver"; fi )
	@( autoheader_ver="`$${AUTOHEADER:-autoheader} --version | grep 'GNU Autoconf'`"; \
           if [ "x$$autoheader_ver" = "x" ]; then echo "Bad autoheader version (should be GNU)"; exit 1; \
           else echo "  $$autoheader_ver"; fi )

PadicoTM/Puk/padico_config.h.in: PadicoTM/configure.ac
	@echo "# Generating $@ ..."
	( cd PadicoTM; $${AUTOHEADER:-autoheader} )

PadicoTM/configure: PadicoTM/configure.ac PadicoTM/adm/*.m4
	@echo "# Generating $@ ..."
	( cd  PadicoTM; $${AUTOCONF:-autoconf} )

PadicoControl/%/configure: PadicoControl/%/configure.ac
	@echo "# Generating $@ ..."
	( cd PadicoControl/$*; $${AUTOCONF:-autoconf} )

clean-config:
	@echo "# Cleaning config... files: ${CONFIG_FILES}"
	@rm -f $(CONFIG_FILES)
	@rm -rf */autom4*.cache/

